'
' Mor-sux: Morsetrainer mit 2 Modi
'
' Modus 1 erzeugt 5er- Gruppen nach der Koch- Methode. (siehe DATA- Zeilen "Morsetabelle_1")
' Der Zeichensatz beginnt in der ersten Lektion mit 2 Zeichen; bei jeder Lektion kommen zwei
' Zeichen dazu (bis Lektion 23), optionale Lektionen 24 - 26 sind Umlaute.
' Lektionsnummer wird mit Museklavier an PC0...PC4 eingestellt
'
' Modus 2 (Pseudo- Lektionsnummern 27-31) gibt zufllige Wrter aus Klartext- Tabelle in Morse aus,
'
' Pseudo- Lektionsnummer 0 erzeugt PARIS- Schleife (fr Geschwindigkeitskontrolle)
'
' Pin PB1 wird als Timer1-Ausgang OC1a verwendet, Ton wird durch Umschalten des
' Pins als Eingang / Ausgang ein- und ausgeschaltet. Tonhhe wird ber Poti an PC5 und den ADC
' eingestellt.
'
' Geschwindigkeit ist in 11 Stufen schaltbar (4 Bits an PD4 bis PD7).
' Unter 60 ZPM werden die Pausen verlngert, um auf niedrigere Geschwindigkeiten zu kommen
' (15 Zeichen pro Minute bis 100 ZPM)
'
' Lektion 31 gibt das Normwort "Paris" fr Geschwindigkeitsmessung aus
'
' Version 2b; Korrekturen:
' - Morsetabelle_1 - in der 5. Datazeile war Zeichen "4" statt "5"
' - Morsetabelle_1 - vor "" war Semikolon statt Komma. Dadurch ist Zeichen <KA> in Zeile 170 nun 51
' - Morsetabelle_2 - in der letzten Datazeile war Semikolon statt Komma
' - korrigiert: Abschaltung Komparator mit Acsr.acd = 1
' - im Powerdown werden nun die Pullup- Widerstnde abgschaltet, sie sorgten fr Dauer-Stromverbrauch
'
'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


$regfile = "m8def.dat"
$crystal = 1000000
$hwstack = 40
$swstack = 10
$framesize = 40
$baud = 9600


Dim Weerndinit As Eram Word                                 ' Initialisierungswert fr den Pseudo-Zufallsgenerator im EEPROM
Dim ___rseed As Word                                        ' Initialisierungs-Variable des Pseudo-Zufallsgenerators, siehe Bascom-Hilfe unter "Rnd()"
'
Dim I As Byte                                               ' Fr temporren Gebrauch als Schleifenzhler
Dim M As Byte                                               ' Index des aktuellen Morsebuchstabens in unserer Tabelle
Dim L As Byte                                               ' fr niederwertigstes Bit beim bitweisen Erzeugen des Morsezeichens
Dim P As Byte                                               ' fr Port- Abfrage Geschwindigkeit und Zeichensatz
Dim Z As Byte                                               ' fr Zeichensatz
Dim G As Byte                                               ' Zhlvariable

Dim R As Word                                               ' fr LowByte von Rnd()
Dim Klartextzeile As String * 160
Dim Klartextzeilennr As Byte
Dim Zeilenlaenge As Byte
Dim Startpos As Byte
Dim Zeilenpos As Byte

Dim Wortindex As Word                                       '
Dim Wortpos As Byte                                         ' Portbits
Dim Wortstring As String * 20
Dim Wortlaenge As Byte
Dim Wortchar As String * 1
Dim Wortbyte As Byte At Wortchar Overlay                    ' Overlay- Variable (Byte- Wert von Wortchar)

Dim Tonhoehe As Word
Dim Punktlaenge As Word                                     ' Punktlnge
Dim Strichlaenge As Word                                    ' Strichlnge
Dim Zeichenpause As Word                                    ' Lnge der Pause zwischen den Zeichen
Dim Wortpause As Word                                       ' Lnge der Pause zwischen den Worten bzw. 5er-Gruppen

Const Anz_data_zeilen = 40                                  ' Anzahl der vorhandenen Data- Zeilen; ggf anpassen !


' Morseton mit Timer0 erzeugen:

Config Timer1 = Timer , Prescale = 1 , Compare A = Toggle , Clear Timer = 1

Start Timer1
Config Adc = Single , Prescaler = Auto , Reference = Avcc
Start Adc


Config Int0 = Low Level
Enable Int0
Enable Interrupts

Acsr.acd = 1                                                'Analog-Komparator ausschalten, spart etwas Strom
Portb = &B11111111                                          ' floatende Eingnge vermeiden
Portc = &B11011111                                          ' floatende Eingnge vermeiden
Portd = &B11111111                                          ' floatende Eingnge vermeiden
Ddrb = &B00000000

On Int0 Onint0

'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -



Main:



' Zufallsgenerator- Initialisierung ist beim Rowalt- Mini- Fuchsjagdsender "Floh" ausgeliehen:

' Zufallsgenerator zur Auswahl der jeweiligen Morsebuchstaben initialisieren:
' Damit der Pseudo-Zufallsgenerator nicht jedesmal nach dem Reset die gleichen Zeichenfolgen erzeugt, mssen wir ihn mit einem
' vernderlichen Startwert fttern. Wir lsen das auf einfachste Weise, indem wir hochzhlen, wie oft das Programm bereits
' gestartet wurde und die Bits etwas rotieren lassen. Der entstandene Wert wird dann wieder im EEPROM abgelegt:

___rseed = Weerndinit                                       'Initialisierungswert aus dem EEPROM holen und Zufallsgenerator damit initialisieren
Rotate ___rseed , Left , 7                                  'Die Bits des Initialisierungswerts rotieren lassen...
Incr ___rseed                                               'und den Wert um 1 erhhen. Damit sollte ein recht zuflliger Eindruck entstehen.
Weerndinit = ___rseed                                       'Und nun den neuen Wert im EEPROM ablegen.



' Auswahl Geschwindigkeit

P = Not Pind                                                ' Abfrage Portbits PD0 - PD7
Shift P , Right , 4                                         ' 4 Bit nach rechts schieben

Select Case P

     Case 0
         Punktlaenge = 74
         Zeichenpause = 2400                                ' eff. 15 ZPM
     Case 1
         Punktlaenge = 74
         Zeichenpause = 1720                                ' eff. 20 ZPM
     Case 2
         Punktlaenge = 74
         Zeichenpause = 1350                                ' eff. 25 ZPM
     Case 3
         Punktlaenge = 74
         Zeichenpause = 1040                                ' eff. 30 ZPM
     Case 4
         Punktlaenge = 74
         Zeichenpause = 820                                 ' eff  40 ZPM
     Case 5
         Punktlaenge = 74
         Zeichenpause = 480                                 ' eff  50 ZPM
     Case 6
         Punktlaenge = 74
         Zeichenpause = 325                                 ' 60 ZPM
     Case 7
         Punktlaenge = 74
         Zeichenpause = 222                                 ' 70 ZPM
     Case 8
         Punktlaenge = 65
         Zeichenpause = 195                                 ' 80 ZPM
     Case 9
          Punktlaenge = 58
          Zeichenpause = 173                                ' 90 ZPM
     Case Else
          Punktlaenge = 52
          Zeichenpause = 155                                ' 100 ZPM

End Select

Strichlaenge = Punktlaenge * 3                              'Strichlnge





' Lebenszeichen / Spruchbeginn

  Waitms 300
  M = 51                                                    ' Zeichen <KA>  (Spruchbeginn)
  M = Lookup(m , Morsetabelle_1)                            ' Morsezeichen aus Tabelle holen
  Gosub Morse
  Wait 2





' Auswahl Lektionen (also Umfang des Zeichensatzes)

P = Not Pinc                                                ' Abfrage und Invertierung Portbits PC0 ... PC7
P = P And &B00011111                                        ' Kapitelnummer; nur Bits PC0...PC4 bercksichtigen

Wortpause = Zeichenpause
Shift Wortpause , Left , 1                                  'Lnge Wortpause = 2 * Zeichenpause


If P > 26 Then                                              ' Abfangen ungltiger Lektionsnummern
   Gosub Klartext
End If

If P = 0 Then                                               ' Verzweigung in die Ausgaben des Geschwindigkeits- Normwortes "Paris"
   Gosub Paris
End If


Z = P                                                       ' Z: Umfang des Zeichensatzes
 Shift Z , Left , 1                                         ' Kapitel 1 : 2 Zeichen; 2 neue Zeichen bei jedem weiteren Kapitel



' Erzeugung von 5er- Gruppen mit Zufallsgenerator

Do

   For G = 1 To 5
   R = Rnd(z)                                               ' M = 0 .... Z
   M = Low(r)                                               ' nur unteres Byte des Wortes verwenden
        M = Lookup(m , Morsetabelle_1)                      ' Morsezeichen aus Tabelle holen
       Gosub Morse
   Next

  Waitms Wortpause

Loop




' "Lektion 27+"  - Klartext

Klartext:

Do

   Restore Klartext_tabelle                                 ' Zeiger auf Anfang Tabelle

   R = Rnd(anz_data_zeilen) + 1                             ' zufllige Zeile auswhlen
   Klartextzeilennr = Low(r)                                ' nur unterstes Byte des Wortes verwenden

   For G = 1 To Klartextzeilennr                            ' alle Zeilen bis zur gewnschten Zeile lesen, da keine direkte
      Read Klartextzeile                                    ' Indizierung mglich (nur die letzte gilt; Rest wird weggeworfen)
   Next

   Zeilenlaenge = Len(klartextzeile)

   R = Rnd(zeilenlaenge)                                    ' in der gewhlten Zeile nun eine zufllige Spalte whlen
   Startpos = Low(r) + 1

   For Zeilenpos = Startpos To Zeilenlaenge                 ' Zeile ab Startposition durchsuchen
      Wortchar = Mid(klartextzeile , Zeilenpos , 1)

      If Wortchar = " " Then                                ' Leerzeichen gefunden (Wortbeginn)
          Incr Zeilenpos                                    ' zum nchsten Zeichen gehen

          For Wortpos = Zeilenpos To Zeilenlaenge           ' spaltenweise das Wort abklappern
              Wortchar = Mid(klartextzeile , Wortpos , 1 )  ' Einzelzeichen lesen

              If Wortchar = " " Then                        ' wenn Wort- Ende gefunden, dann
                  Waitms Wortpause
                  Goto _abbruch                             ' neu anfangen
              End If

              Gosub Klartextausgabe                         ' gefundenes Zeichen ausgeben
          Next

      End If

   Next

_abbruch:

Loop

Return




' Lektion 0 - Ausgabe Normwort fr Geschwindigkeitsmessungen

Paris:

Do

  Wortstring = "Paris "
  Gosub Wortzerlegen

Loop


Wortzerlegen:

   Wortlaenge = Len(wortstring)
   For Wortpos = 1 To Wortlaenge
       Wortchar = Mid(wortstring , Wortpos , 1 )
       Gosub Klartextausgabe
   Next

Return




Klartextausgabe:                                            ' ungltige Zeichen ausfiltern; gltige Zeichen nachschlagen


        Select Case Wortbyte                                ' Umlaute usw. ummappen in den Bereich 91 - 94

           Case Is <= 31 : Wortbyte = 32                    ' ungltige Zeichen in Pause ummappen
           Case 169 : Wortbyte = 91                         ' 
           Case 214 : Wortbyte = 92                         ' 
           Case 220 : Wortbyte = 93                         ' 
           Case 223 : Wortbyte = 94                         ' sz
           Case 228 : Wortbyte = 91                         ' 
           Case 246 : Wortbyte = 92                         ' 
           Case 252 : Wortbyte = 93                         ' 

        End Select

        If Wortbyte > 123 Then                              ' ungltige Zeichen in Pause ummappen
           Wortbyte = 32
        End If


       If Wortbyte > 94 Then                                ' Kleinbuchstaben -> Grossbuchstaben
       Wortbyte = Wortbyte - 32
       End If
       Wortbyte = Wortbyte - 32                             ' Morsetabelle_2 beginnt mit Ascii-Zeichen 32

       M = Lookup(wortbyte , Morsetabelle_2)                ' Morsezeichen aus Tabelle holen
       Gosub Morse

Return



   ' Morsezeichenerzeugung:

   Morse:

      Gosub Poti

      If M = 0 Then                                         ' Sonderfall: Leerzeichen statt nicht morsbarer ASCII- Zeichen
         Waitms Wortpause
      Goto Zeichenende
      End If

      For I = 1 To 8
        If M = 1 Then                                       ' Das Byte hat nur noch den Wert 1; Zeichenende!
          Goto Zeichenende
        End If
        L = M And &B00000001                                ' niederwertigstes Bit lesen
          Ddrb.1 = 1
        If L = 1 Then
           Waitms Strichlaenge                              ' ist das Bit 1 -> dah
          Else
           Waitms Punktlaenge                               ' ist das Bit 0 -> dit
        End If
         Ddrb.1 = 0
        Waitms Punktlaenge                                  ' Pause innerhalb des Morsezeichens
        Shift M , Right , 1                                 ' Bits um eine Stelle nach rechts shiften
      Next I
     Zeichenende:
     Waitms Zeichenpause                                    ' Pause zwischen Morsezeichen

  Return


Poti:

       Tonhoehe = Getadc(5)                                 ' Tonhoehe durch Poti einstellbar
       Tonhoehe = Tonhoehe + 1024                           'fr sinnvollen Einstellbereich
       Ocr1ah = High(tonhoehe)
       Ocr1al = Low(tonhoehe)

Return

End



Onint0:                                                     ' wenn Aus- Taster gedrckt wird, in Powerdown gehen
  Stop Adc
  Stop Timer1
  Portb = &B0                                               ' floatende Eingnge vermeiden
  Portc = &B0                                               ' floatende Eingnge vermeiden
  Portd = &B00000100                                        ' floatende Eingnge vermeiden
  Powerdown
                                         ' floatende Eingnge vermeiden
Return


'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -




Morsetabelle_1:                                             'Reihenfolge Koch- Methode:

'  ->   K M U R E    S N A P T    L W I . J    Z - F O Y    , V G 5 /    Q 9 2 H 3    8 B ? 4 7    C 1 D 6     X =
'  ->   zustzliche: : ( ) + "       ch <KA>

Data &B00001101 , &B00000111 , &B00001100 , &B00001010 , &B00000010

Data &B00001000 , &B00000101 , &B00000110 , &B00010110 , &B00000011

Data &B00010010 , &B00001110 , &B00000100 , &B01101010 , &B00011110

Data &B00010011 , &B01100001 , &B00010100 , &B00001111 , &B00011101

Data &B01110011 , &B00011000 , &B00001011 , &B00100000 , &B00101001

Data &B00011011 , &B00101111 , &B00111100 , &B00010000 , &B00111000

Data &B00100111 , &B00010001 , &B01001100 , &B00110000 , &B00100011

Data &B00010101 , &B00111110 , &B00001001 , &B00100001 , &B00111111

Data &B00011001 , &B00110001

Data &B01000111 , &B00101101 , &B01101101 , &B00101010 , &B01010010

Data &B00011010 , &B00010111 , &B00011100 , &B00011111 , &B00110101




Morsetabelle_2:                                             ' fr Klartext- Ausgabe


'  Ascii 32 - 47   ->   _!"#$%&'()*+,-./
Data 0 , 0 , &B01010010 , 0 , 0 , 0 , &B00101010 , 0 , &B00101101 , &B01101101 , 0 , &B00101010 , &B01110011 , &B01100001
Data &B01101010 , &B00101001

'  Ascii 48 - 57  ->  0123456789
Data &B00111111 , &B00111110 , &B00111100 , &B00111000 , &B00110000 , &B00100000 , &B00100001 , &B00100011 , &B00100111 , &B00101111

'  Ascii 58 - 64  ->  :;<=>?@
Data &B01000111 , &B01110011 , &B00101101 , &B00110001 , &B01101101 , &B01001100 , 0

'  Ascii 65 -  90        @ABCDEFGHIJKLMNOPQRSTUVWXYZ
Data &B00000110 , &B00010001 , &B00010101 , &B00001001 , &B00000010 , &B00010100 , &B00001011 , &B00010000 , &B00000100
Data &B00011110 , &B00001101 , &B00010010 , &B00000111 , &B00000101 , &B00001111 , &B00010110 , &B00011011 , &B00001010
Data &B00001000 , &B00000011 , &B00001100 , &B00011000 , &B00001110 , &B00011001 , &B00011101 , &B00010011

' ASCII 91 -95      s (s statt )
Data &B00011010 , &B00010111 , &B00011100 , &B00001000




Klartext_tabelle:

' insgesamt 40 Data- Zeilen

Data " Als ich mit Bascom und dem LP Mikrocontroller in Kontakt kam, stie ich sehr schnell auf den Befehl getrc5 und war beeindruckt, dass man "
Data " mit einem einzigen Befehl die relativ komplexe Infrarot- Decodierung erschlagen konnte. Eines der ersten Experimente war damals, ihn mit "
Data " einem TSOP1738 und einer vorhandenen Technotrend- DVB-T- Fernsteuerung auszuprobieren. Unschn fand ich, dass ich eine unfrmige Fernbedienung "
Data " mit zahlreichen ungenutzten Tasten bentigte. Aber man kann sich ja einen kompakten Infrarot- Sender selbst bauen; sogar mit einem Attiny13, "
Data " wenn man nicht den Bascom- Befehl rc5send benutzt, sondern die Senderoutine zu Fuss programmiert. Infrarot vs. Funk. Die Infrarot- "
Data " Datenbertragung ist in den letzten Jahren etwas aus der Mode gekommen, denn Funk ist universeller, weil er nicht auf direkte Sichtverbindung "
Data " angewiesen ist, und der Funkbereich wurde dereguliert; durch genehmigungsfreie Funkanwendungen ist es fr Produzenten und fr Endnutzer sehr "
Data " viel einfacher geworden, Funk zu verwenden. Aufgrund des Masseneinsatzes sind auch die Preise stark gefallen. Trotzdem kann Infrarot eine gute "
Data " Wahl sein, denn es gibt Anwendungen, bei denen die geringe Reichweite nicht strt oder sogar erwnscht ist, und der Hardware- Aufwand ist "
Data " denkbar gering und bastelfreundlich, da es sehr preiswerte integrierte IR- Empfnger gibt; ein kleiner Dreibeiner, der nicht einmal einen "
Data " Euro kostet, stellt direkt die zurckgewonnene Bitfolge zur Verfgung. Das verwendete bertragungsprotokoll RC-5 wurde von Philips erschaffen "
Data " und von vielen europischen Unterhaltungselektronik- Herstellern bernommen. Mit dem Niedergang der europischen Hersteller wurde es allerdings "
Data " durch die firmenspezifischen Protokolle asiatischer Hersteller verdrngt, so da man es berwiegend bei etwas lteren Gerten vorfindet. "
Data " IR- Fernsteuerungen arbeiten mit einer Doppel- Modulation: auf das Infrarot- Signal wird ein Untertrger, meist 36 kHz, aufmoduliert, und der "
Data " Untertrger wird mit dem Digitalsignal moduliert. RC-5 arbeitet mit Biphase- Modulation (auch als Manchester bezeichnet). Details sind z.B. "
Data " Strahlenmessung mit BPW34. Die Fotodiode BPW34 kann zur Messung der Radioaktivitt eingesetzt werden. Ein Bauteil fr unter einem Euro als "
Data " Strahlungsdetektor, das macht Spasz. Deshalb wollte ich das mal probieren. Das Bild zeigt meinen ersten funktionierenden Probeaufbau. Auf der "
Data " Fotodiode ist mit Tesafilm ein kleines Stckchen eines radioaktiven Minerals (Uran-Pechblende) befestigt. Die Signale sind sehr klein. Deshalb "
Data " musste ich den Verstrker optimieren und alles abschirmen. Auszerdem muss der ganze Aufbau sorgfltig verdunkelt werden. Am Oszilloskop sieht man "
Data " dann fr jedes Ereignis einen Peak. Mit diesem Aufbau konnte auch getestet Werden , Dass Die Strahlung Eine Alufolie Durchdringen Kann. Dieser "
Data " Verstrker reicht aus, um Peaks bis ber 100 mV zu erkennen. Alles wurde dann auf einen Streifen Lochrasterplatine gebaut. Die Fotodiode steht "
Data " allein auf der Rckseite. Alle anderen Bauteile liegen kompakt auf der Bestckungsseite. Bericht in Elektor: Fotodiode misst Gammastrahlung, "
Data " Strahlungsdetektor mit BPW34. Dieser Aufbau wurde auch in Elektor 6/2011 vorgestellt. Es kamen Fragen zum Aufbau, weil einige Leser einen "
Data " Unterschied zwischen dem Foto und dem Schaltbild entdeckt hatten. Das Foto zeigt eine Variante mit RC-Kopplung und mit geringerem Eingangswiderstand. "
Data "  Nach dem ersten Test bin ich aber wieder auf die direkte Kopplung und den grszeren Eingangswiderstand bergegangen, weil damit ein besserer "
Data " Strabstand erreicht wurde. Die verwendeten Transistoren waren vom Typ BC548. Auf Vorschlag der Elektor-Redaktion wurden jedoch in Elektor die "
Data " noch rauschrmeren BC549 verwendet. Noch ein Tipp zur Funktionskontrolle: Am Ausgang, also am Kollektor des zweiten Transistors messe ich eine "
Data " Spannung von ca. 6 V. Das zeigt, dass der Arbeitspunkt stimmt und alles korrekt funktioniert. Man darf aber nicht erwarten, dass hier schon ein "
Data " verwertbares NF-Signal herauskommt. Die Impulse sind sehr kurz und auch mit dem Oszilloskop nicht leicht zu entdecken. Deshalb wurde ein Komparator "
Data " nachgeschaltet (s.u.). Mit der Schaltungsvariante vom Manfred (s.u.) geht es aber auch mit drei Transistoren auch direkt. Andere Schaltungen "
Data " verwenden Operationsverstrker, ebenfalls mit gutem Erfolg. Die gesamte Schaltung muss dann isoliert und mit Alufolie umwickelt werden. Die "
Data " Alufolie wird mit an Masse gelegt, damit alles gegen elektrische Strungen von auszen abgeschirmt ist. Rechts erkennt man den Abdruck der Fotodiode. "
Data " Hier muss die Probe angenhert werden. Und so sieht das Ausgangssignal ohne eine radioaktive Probe aus, es kommt nur ein gleichmsziges Rauschen: "
Data " Ganz anders mit einer Probe. Nun sieht man positive Impulse, die sogar die Energie der einzelnen Ereignisse zeigen. Das leichte berschwingen nach "
Data " unten wird durch den einfachen Sensorverstrker verursacht. Sicher gibt es am Verstrker und an den Auswertemethoden noch einiges zu verbessern "
Data "  Speichermangel in Bascom? Ein neues Bascom-Projekt fr den Tiny13 wurde begonnen. Beim Kompilieren des Programms brachte der Compiler die "
Data " Fehlermeldung 22: out of SRAM-space. Und das obwohl noch kaum Variablen verwendet wurden. Nach etwas Sucherei wurde der Fehler gefunden: Die "
Data " Einstellungen fr Hwstrack, Swstack und Framesize waren fr ein vorher bearbeitetes Projekt mit dem Mega32 hher eingestellt worden als es dem "
Data " Tiny13 gut Tut. Bascom Das Bild zeigt die Default-Einstellungen. Man kann aber besser im Quelltext die Grssen dieser Speicherbereiche angeben. "
Data " Fr den Tin13 reichen meist auch kleinere Werte. Hwstack=8 reicht fr vier Unterprogrammaufrufe. Swstack wird bei der "